/*
 * Author: Radovan Cerveny
 */

#ifndef MEASUREMENT_PROCESSOR_HPP_
#define MEASUREMENT_PROCESSOR_HPP_

#include "../provisioner/MeasurementProvisionerResults.hpp"
#include "MeasurementProcessorFilter.hpp"
#include "MeasurementProcessorOutput.hpp"
#include <ostream>

namespace measurements {

class MeasurementProcessor {

	static MeasurementResults processMeasurementResults ( const MeasurementResults &, const MeasurementProcessorFilter & );

public:
	static MeasurementProvisionerResults process ( const MeasurementProvisionerResults &, const MeasurementProcessorFilter & );

	static std::string output ( const MeasurementProvisionerResults &, const MeasurementProcessorOutput & );
	static void output ( std::ostream &, const MeasurementProvisionerResults &, const MeasurementProcessorOutput & );
};

}

#endif /* MEASUREMENT_PROCESSOR_HPP_ */
