/*
 * Author: Radovan Cerveny
 */

#include "MeasurementProcessorFilter.hpp"

namespace measurements {

void MeasurementProcessorFilter::add ( FilterType type, const std::string & str ) {
	filters[type].insert ( str );
}

void MeasurementProcessorFilter::remove ( FilterType type, const std::string & str ) {
	filters[type].erase ( str );

	if ( filters[type].empty ( ) ) filters.erase ( type );
}

bool MeasurementProcessorFilter::matches ( FilterType type, const std::string & str ) const {
	auto filtersIter = filters.find ( type );

	if ( filtersIter == filters.end ( ) ) return true;

	const auto & filterSet = filtersIter->second;

	return filterSet.find ( str ) != filterSet.end ( );
}

}
