/*
 * Author: Radovan Cerveny
 */

#ifndef MEASUREMENT_PROCESSOR_OUTPUT_HPP_
#define MEASUREMENT_PROCESSOR_OUTPUT_HPP_

#include "../provisioner/MeasurementProvisionerResults.hpp"
#include <ostream>

namespace measurements {

struct MeasurementProcessorOutput {
	enum class OutputFormat {
		XML, STATS,	CSV, HTML
	};

	enum class OutputEngine {
		TIME, MEMORY, COUNTER
	};

	OutputFormat outputFormat;
	OutputEngine outputEngine;
	std::string	 outputEngineAttr;

	static void outputXml ( std::ostream &, const MeasurementProvisionerResults &, const MeasurementProcessorOutput & );
	static void outputStats ( std::ostream &, const MeasurementProvisionerResults &, const MeasurementProcessorOutput & );
	static void outputCsv ( std::ostream &, const MeasurementProvisionerResults &, const MeasurementProcessorOutput & );
	static void outputHtml ( std::ostream &, const MeasurementProvisionerResults &, const MeasurementProcessorOutput & );

	static std::string getData ( const MeasurementFrame &, const MeasurementProcessorOutput & );
};

}

#endif /* MEASUREMENT_PROCESSOR_OUTPUT_HPP_ */
