/*
 * Author: Radovan Cerveny
 */

#ifndef MEASUREMENT_PROVISIONER_CONFIGURATION_XML_HPP_
#define MEASUREMENT_PROVISIONER_CONFIGURATION_XML_HPP_

#include <deque>
#include "sax/Token.h"
#include "MeasurementProvisionerConfiguration.hpp"

namespace measurements {

class MeasurementProvisionerConfigurationXml {
	static std::string MEASUREMENT_PROVISIONER_TAG;

	static std::string ENVIRONMENT_TAG;
	static std::string WORKING_DIRECTORY_TAG;
	static std::string PIPELINE_ITERATIONS_TAG;

	static std::string INPUT_DATA_TAG;
	static std::string INPUT_DATA_BATCH_TAG;
	static std::string INPUT_DATA_BATCH_ATTR_DEPENDENCY_NAME;

	static std::string INPUT_DATA_FILE_TAG;
	static std::string INPUT_DATA_GENERATOR_TAG;

	static std::string INPUT_DATA_ATTR_ID_NAME;
	static std::string INPUT_DATA_ATTR_COUNT_NAME;

	static std::string PIPELINES_TAG;
	static std::string PIPELINE_TAG;
	static std::string COMMAND_TAG;

	static std::string COMMAND_ATTR_MEASURE_NAME;

	static std::string MEASUREMENT_CONFIGURATION_TAG;

	static void parseMeasurementProvisioner ( MeasurementProvisionerConfiguration &, std::deque < sax::Token >::iterator & );

	static void parseEnvironment ( MeasurementProvisionerConfiguration &, std::deque < sax::Token >::iterator & );

	static void parseInputData ( MeasurementProvisionerConfiguration &, std::deque < sax::Token >::iterator & );
	static void parseInputBatch ( MeasurementProvisionerConfiguration &, std::deque < sax::Token >::iterator & );
	static MPCInputDatum parseInputDatum ( const std::string &, std::deque < sax::Token >::iterator & );

	static void parsePipelines ( MeasurementProvisionerConfiguration &, std::deque < sax::Token >::iterator & );
	static void parsePipeline ( MPCPipeline &, std::deque < sax::Token >::iterator & );
	static MPCPipelineCommand parsePipelineCommand ( std::deque < sax::Token >::iterator & );
	static void parseMeasurementConfiguration ( MeasurementProvisionerConfiguration &, std::deque < sax::Token >::iterator & );

public:
	static MeasurementProvisionerConfiguration parse ( std::deque < sax::Token > & );
};

}

#endif /* MEASUREMENT_PROVISIONER_CONFIGURATION_XML_HPP_ */
