/*
 * Author: Radovan Cerveny
 */

#ifndef MEASUREMENT_PROVISIONER_RESULTS_HPP_
#define MEASUREMENT_PROVISIONER_RESULTS_HPP_

#include <measure>
#include <ostream>

namespace measurements {

struct MPRPipelineCommandResults {
	std::string						 command;
	MeasurementResults measurementResults;
};

struct MPRPipelineStatus {
	int			exitCode;
	std::string errorOrigin;
	std::string errorValue;
};

struct MPRPipelineResults {
	MPRPipelineStatus						  pipelineStatus;
	std::vector < MPRPipelineCommandResults > commandResults;
};

struct MPRResults {
	std::vector < std::pair < int, std::string > > inputs;
	std::vector < MPRPipelineResults >			   pipelineResults;
};

struct MeasurementProvisionerResults {
	std::vector < MPRResults > results;
};

std::ostream & operator <<( std::ostream &, const MeasurementProvisionerResults & );
}

#endif /* MEASUREMENT_PROVISIONER_RESULTS_HPP_ */
